#include "StSoundLibrary.h"
#include "YmMusic.h"

#include <stdio.h>

#ifdef __linux__
#define __declspec(x)
#endif

extern "C"
{ 
  void __declspec(dllexport) *DLL_LoadYM(const char* szFileName)
  {
    YMMUSIC *pMusic = ymMusicCreate();

    if (ymMusicLoad(pMusic,szFileName))
    {
      ymMusicSetLoopMode(pMusic,YMFALSE);
      ymMusicPlay(pMusic);
      return pMusic;
    }
  
    ymMusicDestroy(pMusic);

    return 0;
  }

  void __declspec(dllexport) DLL_FreeYM(void* ym)
  {
    ymMusicStop(ym);
    ymMusicDestroy(ym);
  }

  int __declspec(dllexport) DLL_FillBuffer(void* ym, char* szBuffer, int iSize)
  {
    if (ymMusicCompute(ym,(ymsample*)szBuffer,iSize/2))
      return iSize;
    else
      return 0;
  }

  unsigned long __declspec(dllexport) DLL_Seek(void* ym, unsigned long timepos)
  {
    if (ymMusicIsSeekable(ym))
    {
      ymMusicSeek(ym,timepos);
      return timepos;
    }

    return 0;
  }

  const char __declspec(dllexport) *DLL_GetTitle(void* ym)
  {
    ymMusicInfo_t info;
    ymMusicGetInfo(ym,&info);
    return info.pSongName;
  }

  const char __declspec(dllexport) *DLL_GetArtist(void* ym)
  {
    ymMusicInfo_t info;
    ymMusicGetInfo(ym,&info);
    return info.pSongAuthor;
  }

  unsigned long __declspec(dllexport) DLL_GetLength(void* ym)
  {
    ymMusicInfo_t info;
    ymMusicGetInfo(ym,&info);
    return info.musicTimeInSec;
  }
}

